#include <stdint.h>
#include <lpc1768.h>
#include <pconp.h>
#include <pcb.h>
#include <gpio.h>
#include <spi.h>

__inline static void spi_delay1(void)
{
	uint8_t de=0;
	for(de=255;de>=1;de--);
}

__inline static void Set_SPI_Data_Size(Spi_Data_Size_t Spi_Data_Size)
{
	switch(Spi_Data_Size)
	{
		case SPI_DATA_8BIT: LPC_SPI->SPCR &=~ (1<<2);
												
												LPC_SPI->SPCR |= (1<<11);
												LPC_SPI->SPCR &=~(1<<10);
												LPC_SPI->SPCR &=~ (1<<9);
												LPC_SPI->SPCR &=~ (1<<8);
												break;
		case SPI_DATA_16BIT: LPC_SPI->SPCR |= (1<<2);
												
												LPC_SPI->SPCR &=~(1<<11);
												LPC_SPI->SPCR &=~(1<<10);
												LPC_SPI->SPCR &=~ (1<<9);
												LPC_SPI->SPCR &=~ (1<<8);
												break;
	}
}

__inline static void Set_SPI_MODE(Spi_Mode_t Spi_Mode)
{
	switch(Spi_Mode)
	{
		case MODE0:	LPC_SPI->SPCR &=~ (1<<3);
								LPC_SPI->SPCR &=~ (1<<4);
								break;
		case MODE1:	LPC_SPI->SPCR &=~ (1<<3);
								LPC_SPI->SPCR |= (1<<4);
								break;
		case MODE2:	LPC_SPI->SPCR |=  (1<<3);
								LPC_SPI->SPCR &=~ (1<<4);
								break;
		case MODE3:	LPC_SPI->SPCR |=  (1<<3);
								LPC_SPI->SPCR |=  (1<<4);
								break;
	}
}
__inline static void Set_SPI_Clock_1MHZ(void)
{
	Update_SPI_CCR(24);
}

void Set_SPI_Base_Config(void)	//PCONP,PCB 
{
	Enable_SPI();
	
	Config_Pin_Function(PORT0,PIN15,PIN_FUN3);	//SCK
	Config_Pin_Function(PORT0,PIN17,PIN_FUN3);	//MISO
	Config_Pin_Function(PORT0,PIN18,PIN_FUN3);	//MOSI
	
//	Config_Pin_Mode(PORT0,PIN15,PIN_MODE_TRISTATED);
//	Config_Pin_Mode(PORT0,PIN17,PIN_MODE_PULLUP_ENABLE);
//	Config_Pin_Mode(PORT0,PIN18,PIN_MODE_PULLUP_ENABLE); 
	
//	Config_Pin_Function(PORT0,PIN16,PIN_FUN3);	//SSEL 
	Config_Pin_Function(PORT0,PIN16,PIN_FUN3);	//SSEL 
//	Config_GPIO_Input(0,16);		//SSEl should be input in SPI slave mode

}

void Set_SPI_Core_Config(void)	//SPCR,SPDR,SPSR,SPCCR,SPINT
{
	//SPCR - SPI Data Transfer Size
	Set_SPI_Data_Size(SPI_DATA_8BIT);

	//SPCR - MODE Select 
	Set_SPI_MODE(MODE0);

	//SPCR - MASTER/SLAVE Select 
		Config_SPI_Slave();

	//SPCR - Interrupt Enable/Disable Select 
//		Enable_SPI_Interrupt();
		Disable_SPI_Interrupt();
	
	//Enable SPI interrupt in NVIC
//		NVIC_EnableIRQ(SPI_IRQn);
	
	//SPCCR- PCLK/SPCCR=18/18=1Mhz
//	Set_SPI_Clock_1MHZ();
}

void Init_SPI(void)
{
	Set_SPI_Base_Config();
	
	Set_SPI_Core_Config();
}

uint8_t slave_data=0,dummy;
uint8_t Set_SPI_Data_Transfer()
{
	//uint8_t slave_data=0;
//	dummy = Read_SPI_Status();
	
//	slave_data = Read_SPI_Data;
		
	Write_SPI_Data(0x05);
		
	Wait_SPI_Transfer();
	
//	Write_SPI_Data(0x05);
	
	slave_data = Read_SPI_Data;
	
	return slave_data;
}

uint8_t ch_data, re_data;
void Aux_to_Primary(void)
{
	static uint8_t test_data=1;
	if(test_data>=255)
	{
		test_data=1;
	}
	ch_data=test_data;
	
	Select_SPI_Slave();
	
	re_data=Set_SPI_Data_Transfer();
	
	Deselect_SPI_Slave();
	
	spi_delay1();
	
	test_data++;
}


//void SPI_IRQHandler(void)		//interrupt hanhler for spi
//{
//	if(LPC_SPI->SPSR&(1<<7))
//	{
	/*	read the slave data		*/
//		Clear_SIF_Interrupt();
//		slave_data=Read_SPI_Data;
//	}
//}

